/* Compile usign gcc -Wall libX11-colour.c -lX11 -o libX11-colour.
This diplays colour mappings. Check the screen for two intersecting lines in brown colour
with a circle in centre and two rectangles ( one in red ) */
#include <stdio.h>
#include <stdlib.h>
#include  <X11/Xlib.h>
#include  <X11/Xutil.h>
#include <unistd.h>

int main( argc, argv )

{       /* main */
	Display         *display;
	int             screen;
	Window          rootwindow;
	Window          window;
	GC              gc;
	Colormap screen_colormap;   /* Colourmap */
	XColor red, brown, yellow;
	Status status;

	/* Connect to an X server. */
	display = XOpenDisplay( (char *) NULL );

	if ( display == (Display*) NULL )
	{
		fprintf( stderr, "Error opening in display\n" );
		exit( -1 );
	}

	screen     = DefaultScreen( display );
	rootwindow = RootWindow( display, screen );
	/*     Create a window */
	window = XCreateSimpleWindow( display, RootWindow( display, screen ), 5, 5, 500, 500, 2, WhitePixel( display, 0 ), WhitePixel( display, 0 ) );

	/*	 Create a Graphics Context      */
	gc = XCreateGC( display, window, 0L, (XGCValues *) NULL );

	XSetForeground( display, gc, WhitePixel( display, screen ) );

	/*  Set the background color. */
	XSetBackground( display, gc, BlackPixel( display, screen ) );

	XMapWindow( display, window );
	XFlush( display );

	/* Get the default colormap */
	screen_colormap = DefaultColormap(display, screen);

	/* allocate the set of colors  */
	status = XAllocNamedColor(display, screen_colormap, "red", &red, &red);
	if (status == 0) {
    		printf("XAllocNamedColor - failed to allocated 'red' color.\n");
		exit(1);
	}
	status = XAllocNamedColor(display, screen_colormap, "brown", &brown, &brown);
	if (status == 0) {
		printf("XAllocNamedColor - failed to allocated 'brown' color.\n");
		exit(1);
	}
	status = XAllocNamedColor(display, screen_colormap, "yellow", &yellow, &yellow);
	if (status == 0) {
		printf("XAllocNamedColor - failed to allocated 'yellow' color.\n");
		exit(1);
	}
  
	/* Draw two intersecting lines in brown*/
	XSetForeground(display, gc, brown.pixel);
	XDrawLine(display, window, gc, 100, 0, 100, 250);
	XDrawLine(display, window, gc, 0, 150, 250, 150);

	/* Draw a circle with yellow */
 	XSetForeground(display, gc, yellow.pixel);
	XDrawArc(display, window, gc, 100-(30/2), 150-(30/2), 30, 30, 0, 360*64);

	sleep(6);

	/* Create rectangle in black */ 
	XSetForeground(display, gc, BlackPixel(display, screen));
	XDrawRectangle(display, window, gc, 150, 180, 80, 90);

	/*Create rectangle in red colour */
	XSetForeground(display, gc, red.pixel);
	XFillRectangle(display, window, gc, 10, 10, 80, 90);

	sleep(4);
	XFlush(display);

	sleep(10);

	XCloseDisplay(display);
	return 0;
}

