/*Compile using" gcc -Wall libX11-cursorfont.c -lX11 -o libX11-cursorfont"
keep pointer inside screen. Cursor will appear in watch shape and crosshair type */
#include <stdio.h>
#include <stdlib.h>
#include  <X11/Xlib.h>
#include  <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <unistd.h>

int main( argc, argv )

{       /* main */
	Display         *display;
	int             screen;
	Window          rootwindow;
	Window          window;
	GC              gc;
	Cursor		cursor; 

	/* Connect to an X server. */
	display = XOpenDisplay( (char *) NULL );

	if ( display == (Display*) NULL )
	{
		fprintf( stderr, "Error opening in display\n" );
		exit( -1 );
	}

	screen     = DefaultScreen( display );
	rootwindow = RootWindow( display, screen );
	/*     Create a window */
	window = XCreateSimpleWindow( display, RootWindow( display, screen ), 5, 5, 500, 500, 2, WhitePixel( display, 0 ), WhitePixel( display, 0 ) );

	/*	 Create a Graphics Context  */
	gc = XCreateGC( display, window, 0L, (XGCValues *) NULL );

	/* Set the foreground colour to white */
	XSetForeground( display, gc, WhitePixel( display, screen ) );

	/*  Set the background color to black */
	XSetBackground( display, gc, BlackPixel( display, screen ) );

	XMapWindow( display, window );
	XFlush( display );

	/* create cursors of shape "watch", crosshair */
	cursor = XCreateFontCursor(display, XC_watch);
	/* attach  cursor to window. */
	XDefineCursor(display, window, cursor);
	XSync(display, False);

	sleep(6);

	/* detach cursor from window. */
	XUndefineCursor(display, window);

	cursor = XCreateFontCursor(display, XC_crosshair);
	/* attach cursor to window. */
	XDefineCursor(display, window, cursor);
	XSync(display, False);

	sleep(6);

	/* detach cursor from window. */
	XUndefineCursor(display, window);

	XDestroyWindow(display, window);
	XCloseDisplay(display);

	return 0;
}

