/* Compile using "gcc -Wall libX11-keycode.c -lX11 -o libX11-keycode"
Press keys and it will display the key pressed and its keycode */
#include <stdio.h>
#include <stdlib.h>
#include  <X11/Xlib.h>
#include  <X11/Xutil.h>
#include  <X11/keysymdef.h>
#include  <X11/keysym.h>

int main( argc, argv )

{       /* main */
	Display         *display;
	int             screen;
	Window          rootwindow;
	Window          window;
	GC              gc;
	XEvent report;
	/* Connect to an X server. */
	display = XOpenDisplay( (char *) NULL );

	if ( display == (Display*) NULL )
	{
		fprintf( stderr, "Error opening in display\n" );
		exit( -1 );
	}

	screen     = DefaultScreen( display );
	rootwindow = RootWindow( display, screen );
	/*     Create a window */
	window = XCreateSimpleWindow( display, RootWindow( display, screen ), 5, 5, 500, 500, 2, WhitePixel( display, 0 ), WhitePixel( display, 0 ) );

	/*  Ask for keyboard input      */
	XSelectInput (display, window, ButtonPressMask|KeyPressMask);
	/*	 Create a Graphics Context  */
	gc = XCreateGC( display, window, 0L, (XGCValues *) NULL );

	/* Set the foreground colour */
	XSetForeground( display, gc, WhitePixel( display, screen ) );

	/*  Set the background color to black */
	XSetBackground( display, gc, BlackPixel( display, screen ) );

	/* Project the window  */
	XMapWindow( display, window );
	XFlush( display );

	while (1)  {
		XNextEvent(display, &report);
		switch  (report.type) {
			case Expose:
			break;
			case KeyPress:
				printf("KeySym: %s\n", XKeysymToString(XLookupKeysym(&report.xkey, 0)));
				fprintf (stdout, "key #%ld was pressed.\n", XLookupKeysym(&report.xkey, 0));
			break;
		}
	}
	return 0;
}
