/* Compile using "gcc -Wall libX11-window.c -lX11 -o libX11-window"
Press space-bar key and the window will resize.
Wait for sometime, window will resize again and move down */
#include <stdio.h>
#include <stdlib.h>
#include  <X11/Xlib.h>
#include  <X11/Xutil.h>
#include  <X11/keysymdef.h>
#include  <X11/keysym.h>
#include <unistd.h>

int main( argc, argv )

{       /* main */
	Display         *display;
	int             screen;
	Window          rootwindow;
	Window          window;
	GC              gc;
	XEvent report;
	/* Connect to an X server. */
	display = XOpenDisplay( (char *) NULL );

	if ( display == (Display*) NULL )
	{
		fprintf( stderr, "Error opening in display\n" );
		exit( -1 );
	}

	screen     = DefaultScreen( display );
	rootwindow = RootWindow( display, screen );
	/*     Create a window */
	window = XCreateSimpleWindow( display, RootWindow( display, screen ), 5, 5, 500, 500, 2, WhitePixel( display, 0 ), WhitePixel( display, 0 ) );

	/*  Ask for Expose, keyboard input      */
	XSelectInput (display, window, ButtonPressMask|KeyPressMask);
	/*	 Create a Graphics Context (GC) for drawing text     */
	gc = XCreateGC( display, window, 0L, (XGCValues *) NULL );

	/* set foreground colour */
	XSetForeground( display, gc, WhitePixel( display, screen ) );

	/*  Set the background color to black. */
	XSetBackground( display, gc, BlackPixel( display, screen ) );

	/* Project the window  */
	XMapWindow( display, window );
	XFlush( display );

	while (1)  {
		XNextEvent(display, &report);
		switch  (report.type) {
			case Expose:
			break;
			case KeyPress:
				if (XLookupKeysym(&report.xkey, 0) == XK_space) {
					XResizeWindow(display, window, 350, 350);
					XFlush(display);
					sleep(2);
					XResizeWindow(display, window, 150, 150);
					XFlush(display);
					sleep(2);
					XMoveWindow(display, window, 200, 200);
				}
			break;
		}
	}
	return 0;
}
