/* Compile using gcc -Wall libx11-xcb.c -lX11 -lX11-xcb -o libx11-xcb .
Press any key, it will print "key pressed" in screen */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <xcb/xcb.h>
#include <X11/Xlib.h>
#include <X11/Xlib-xcb.h>

int main() {
	xcb_connection_t *c;
	xcb_screen_t *s;
	xcb_window_t w;
	uint32_t mask;
	uint32_t values[2];
	xcb_generic_event_t *e;

	Display *dpy = XOpenDisplay(NULL);
	if (dpy) {
		c = XGetXCBConnection(dpy);
		XSetEventQueueOwner(dpy, XCBOwnsEventQueue);
	}

	/* Get the screen */
	s = xcb_setup_roots_iterator (xcb_get_setup (c)).data;
	/* Ask for our window's Id */
	w = xcb_generate_id (c);

	/* Create the window */
	mask = XCB_CW_BACK_PIXEL | XCB_CW_EVENT_MASK;
	values[0] = s->white_pixel;
	values[1] = XCB_EVENT_MASK_EXPOSURE | XCB_EVENT_MASK_KEY_PRESS;

	xcb_create_window (c, XCB_COPY_FROM_PARENT, w, s->root, 10, 10, 100, 100, 1, XCB_WINDOW_CLASS_INPUT_OUTPUT, s->root_visual, mask, values);


	/* Map the window on the screen */
	xcb_map_window (c, w);
	xcb_flush (c);

	int type;
	while ((e = xcb_wait_for_event (c))) {
	type = (e->response_type & ~0x80);
	switch (type) {
	case XCB_EXPOSE:
		printf ("EXPOSE\n");
		xcb_flush (c);
	break;
	case XCB_KEY_PRESS:
		printf("key press . \n");
	break;
	default:
	break;
	}
	xcb_flush (c);
	free(e);
	}

	return 0;
}
