/* Compile the code using "gcc -Wall libX11-xkb.c -lX11 -o libX11-xkb"
Execute "setxkbmap, or xmodmap or xkbcomp.
xkb will capture the event */
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/XKBlib.h>
#include <X11/keysym.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int
main(int argc,
     char **argv)
{
	Display *xdisplay;
	XEvent xevent;
	int xkb_op;
	int xkb_ev;
	int xkb_eb;

	xdisplay = XOpenDisplay(NULL);

	XSynchronize(xdisplay, True);

	XkbQueryExtension(xdisplay, &xkb_op, &xkb_ev, &xkb_eb, NULL, NULL);

	XkbSelectEvents(xdisplay, XkbUseCoreKbd, XkbMapNotifyMask | XkbNewKeyboardNotifyMask, XkbMapNotifyMask| XkbNewKeyboardNotifyMask);

	while (XNextEvent(xdisplay, &xevent) == Success) {
		if (xevent.type == (xkb_ev + XkbEventCode)) {
			XkbEvent *event = (XkbEvent*)&xevent;
			printf("Xkb event received\n");

			if (event->any.xkb_type == XkbMapNotify) {
				XkbMapNotifyEvent *map = &event->map;

				printf("XkbMapNotify\n");

				XkbRefreshKeyboardMapping(map);

				XkbSelectEvents(xdisplay, XkbUseCoreKbd, XkbMapNotifyMask | XkbNewKeyboardNotifyMask, XkbMapNotifyMask | XkbNewKeyboardNotifyMask);
			} else {
				printf("Xkb event xkb_type=%u\n",
				event->any.xkb_type);
			}
			} 
		else {
			printf("event type %d\n", xevent.type);
		}
	}

	return 0;
}

